Page MenuHomeFreeBSD

Add a new security/isal-kmod port.
ClosedPublic

Authored by jhb on Jun 29 2020, 10:57 PM.
Tags
None
Referenced Files
Unknown Object (File)
Tue, Jun 18, 6:20 AM
Unknown Object (File)
May 21 2024, 5:18 PM
Unknown Object (File)
May 21 2024, 11:20 AM
Unknown Object (File)
May 9 2024, 9:40 AM
Unknown Object (File)
May 9 2024, 9:39 AM
Unknown Object (File)
May 9 2024, 9:39 AM
Unknown Object (File)
May 9 2024, 9:39 AM
Unknown Object (File)
May 4 2024, 5:41 PM

Details

Summary

This port builds a kernel crypto device driver which uses routines from
Intel's ISA-L crypto library to perform AES-GCM encryption and decryption.

Test Plan
  • make check-plist for the port
  • have tested the driver with KTLS + ktls_ocf.ko and with cryptocheck

Diff Detail

Repository
rP FreeBSD ports repository
Lint
No Lint Coverage
Unit
No Test Coverage
Build Status
Buildable 32051
Build 29576: arc lint + arc unit

Event Timeline

jhb requested review of this revision.Jun 29 2020, 10:57 PM

This might get some more testing of the driver before it should be committed, but this isn't a bad place to coordinate testing if others are interested in testing I suppose. On my wimpy little 4-core Haswell box KTLS with aesni was able to push about 35 Gbps in a simple https benchmark vs 41-42 Gbps with this module (and 42-43 Gbps with the KTLS-specific ktls-isa_l-crypto-kmod port).

security/isal-kmod/Makefile
14

I think you want to tack on IGNORE_FreeBSD_11= ... and presumably IGNORE_FreeBSD_12= .... It's unfortunate that we don't have an ONLY_FOR_FreeBSD_13= since this probably won't build against, e.g., Dragonfly.

security/isal-kmod/Makefile
11

If it's BSD3CLAUSE, why not base?

lwhsu added inline comments.
security/isal-kmod/pkg-descr
7

Do you want to mention that the source of this port is from https://github.com/bsdjhb/ocf_isa_l and 01org is the upstream?

security/isal-kmod/Makefile
11

It requires yasm or nasm to compile the assembly files which we don't have in base.

jhb marked 2 inline comments as done.Jul 16 2020, 5:47 PM
jhb added inline comments.
security/isal-kmod/Makefile
14

It would need to be some kind of ONLY_FOR_FreeBSD_13+ to mean 13 and beyond. I think it's simpler to add the IGNORE for 11 and 12. OTOH, an ONLY_FOR_FreeBSD would perhaps be helpful.

security/isal-kmod/pkg-descr
7

I added my repo as a WWW, not sure if I need words as well?

jhb marked 2 inline comments as done.
  • Address some review feedback.
  • Bump to a newer hash with cosmetic cleanups, NFC.
mat requested changes to this revision.Jul 21 2020, 12:29 PM
mat added inline comments.
security/isal-kmod/Makefile
31

No need for that. And change the include at the end to bsd.port.mk.

security/isal-kmod/pkg-descr
8–9

Only one WWW line supported.

This revision now requires changes to proceed.Jul 21 2020, 12:29 PM
jhb marked 2 inline comments as done.
  • Address feedback from mat@.

Is there a reason to not import this into base? The isa-l library is BSD-licensed and has a very small footprint.

In D25514#574176, @gbe wrote:

Is there a reason to not import this into base? The isa-l library is BSD-licensed and has a very small footprint.

The problem is that the isa-l library requires yasm to compile

In D25514#574176, @gbe wrote:

Is there a reason to not import this into base? The isa-l library is BSD-licensed and has a very small footprint.

The problem is that the isa-l library requires yasm to compile

Ah, okay, I have seen that yasm is also BSD-licensed, but importing a new compiler for a new library isn't worth the hassle.

This revision is now accepted and ready to land.Aug 3 2020, 12:13 PM
This revision was automatically updated to reflect the committed changes.